#import "FBBrowserListController.h"
#import "FBPrincipal.h"

@implementation FBBrowserListController

- (void)outlineViewDoubleClick:(id)sender
{
    NSLog(@"%@ %s", [self className], _cmd);
    
    FileSystemItem * selectedItem = [outlineView itemAtRow:[outlineView selectedRow]];

    if ([selectedItem numberOfChildren] != -1) {
        if ([outlineView isItemExpanded:selectedItem])
          [outlineView collapseItem:selectedItem];
        else
          [outlineView expandItem:selectedItem];
    } else {
        NSLog(@"open file %@", [selectedItem fullPath]);
        NSMutableArray * array = [NSMutableArray array];
        [array addObject:[selectedItem fullPath]];
        [[principal mediator] openFiles:array];
    }
}

- (void)awakeFromNib
{
    NSLog(@"%@ %s", [self className], _cmd);

    rootItem = [[FileSystemItem alloc] initWithPath:@"/Users/mtolton/"];

    [outlineView setTarget:self];
    [outlineView setDoubleAction:@selector(outlineViewDoubleClick:)];

    [[principal mediator] addPlugInView:scrollView withTitle:@"File Browser"];
}
 
- (void)changeRootDirectoryTo:(NSString *)path
{
    NSLog(@"%@ %s", [self className], _cmd);
    [rootItem release];
    rootItem = [[FileSystemItem alloc] initWithPath:path];
    [outlineView reloadItem:nil];
}

- (void)dealloc
{
    [scrollView release]; scrollView = nil;
    [rootItem release]; rootItem = nil;
    [super dealloc];
}

- (int)outlineView:(NSOutlineView *)outlineView numberOfChildrenOfItem:(id)item
{
    return (item == nil) ? 1 : [item numberOfChildren];
}
 
- (BOOL)outlineView:(NSOutlineView *)outlineView isItemExpandable:(id)item
{
    return (item == nil) ? YES : ([item numberOfChildren] != -1);
}
 
- (id)outlineView:(NSOutlineView *)outlineView
    child:(int)index
    ofItem:(id)item
{
    return (item == nil) ? rootItem : [item childAtIndex:index];
}
 
- (id)outlineView:(NSOutlineView *)outlineView
    objectValueForTableColumn:(NSTableColumn *)tableColumn
    byItem:(id)item
{
    return (item == nil) ? @"/" : [item relativePath];
}
 
@end

